// GLView.h : interface of the GLView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLVIEW_H__B0926274_6C4F_11D1_8F9A_0000C0FB6CD8__INCLUDED_)
#define AFX_GLVIEW_H__B0926274_6C4F_11D1_8F9A_0000C0FB6CD8__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class GLView : public CView
{
protected: // create from serialization only
	GLView();
	DECLARE_DYNCREATE(GLView)

public:
	CModelDoc* GetDocument();
	CClientDC	*m_pDC;

  /*
   * Routines to set up and  use the OpenGL API through WGL.
   */

  // Set up the 3D API.
  HRESULT InitAPI(void);

  // Create the Modeller's view class to interface to.
  class Mirage::WGLView *CreateModellerView(void);

  // Release the 3D API.
  void ReleaseAPI(void);

  /*
   * OpenGL-specific member functions
   */
	void CreateRGBPalette(void);
  HRESULT SetupPixelFormat(void);
  unsigned char ComponentFromIndex(int i, UINT nbits, UINT shift);

// GL attributes
private:
  // Used during mouse drags. Which mouse button are we dragging with?
  int drag_leftbutton;

  int bAPICreated;
	HGLRC hGLRenderContext;

  // The View onto the modelled object is a WGLView.
  class Mirage::WGLView *modeller_view;

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(GLView)
	public:
	virtual void OnDraw(CDC* pDC);
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	void windowspace_to_viewspace(CPoint windowPt, double *view_x, double *view_y);

  virtual ~GLView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(GLView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in ModelView.cpp
inline CModelDoc* GLView::GetDocument()
   { return (CModelDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GLVIEW_H__B0926274_6C4F_11D1_8F9A_0000C0FB6CD8__INCLUDED_)
