// ModelDoc.cpp : implementation of the CModelDoc class
//

#include "stdafx.h"
#include "ModelApp.h"

#include "ModelDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CModelDoc

IMPLEMENT_DYNCREATE(CModelDoc, CDocument)

BEGIN_MESSAGE_MAP(CModelDoc, CDocument)
	//{{AFX_MSG_MAP(CModelDoc)
	ON_COMMAND(ID_LINK_AND, OnLinkAnd)
	ON_COMMAND(ID_LINK_MINUS, OnLinkMinus)
	ON_COMMAND(ID_LINK_PLUS, OnLinkPlus)
	ON_COMMAND(ID_DELETE, OnDelete)
	ON_UPDATE_COMMAND_UI(ID_DELETE, OnUpdateDelete)
	ON_UPDATE_COMMAND_UI(ID_LINK_AND, OnUpdateLinkAnd)
	ON_UPDATE_COMMAND_UI(ID_LINK_MINUS, OnUpdateLinkMinus)
	ON_UPDATE_COMMAND_UI(ID_LINK_PLUS, OnUpdateLinkPlus)
	ON_UPDATE_COMMAND_UI(ID_PRIMITIVE, OnUpdatePrimitive)
	ON_COMMAND(ID_PRIMITIVE_SPHERE, OnPrimitiveSphere)
	ON_UPDATE_COMMAND_UI(ID_PRIMITIVE_SPHERE, OnUpdatePrimitiveSphere)
	ON_COMMAND(ID_PRIMITIVE_CONE, OnPrimitiveCone)
	ON_UPDATE_COMMAND_UI(ID_PRIMITIVE_CONE, OnUpdatePrimitiveCone)
	ON_COMMAND(ID_PRIMITIVE_CUBE, OnPrimitiveCube)
	ON_UPDATE_COMMAND_UI(ID_PRIMITIVE_CUBE, OnUpdatePrimitiveCube)
	ON_COMMAND(ID_PRIMITIVE_CYLINDER, OnPrimitiveCylinder)
	ON_UPDATE_COMMAND_UI(ID_PRIMITIVE_CYLINDER, OnUpdatePrimitiveCylinder)
	ON_COMMAND(ID_PRIMITIVE_PLANE, OnPrimitivePlane)
	ON_UPDATE_COMMAND_UI(ID_PRIMITIVE_PLANE, OnUpdatePrimitivePlane)
	ON_COMMAND(ID_PRIMITIVE_TORUS, OnPrimitiveTorus)
	ON_UPDATE_COMMAND_UI(ID_PRIMITIVE_TORUS, OnUpdatePrimitiveTorus)
	ON_COMMAND(ID_PRIMITIVE_TRUNCCONE, OnPrimitiveTrunccone)
	ON_UPDATE_COMMAND_UI(ID_PRIMITIVE_TRUNCCONE, OnUpdatePrimitiveTrunccone)
	ON_COMMAND(ID_PRIMITIVE_UNITCYL, OnPrimitiveUnitcyl)
	ON_UPDATE_COMMAND_UI(ID_PRIMITIVE_UNITCYL, OnUpdatePrimitiveUnitcyl)
	ON_COMMAND(ID_GOURAUD, OnGouraud)
	ON_UPDATE_COMMAND_UI(ID_GOURAUD, OnUpdateGouraud)
	ON_COMMAND(ID_CHANGETERMINAL, OnChangeterminal)
	ON_UPDATE_COMMAND_UI(ID_CHANGETERMINAL, OnUpdateChangeterminal)
	ON_COMMAND(ID_SHOWTERMINAL, OnShowterminal)
	ON_UPDATE_COMMAND_UI(ID_SHOWTERMINAL, OnUpdateShowterminal)
	ON_COMMAND(ID_TRANSLATE, OnTranslate)
	ON_UPDATE_COMMAND_UI(ID_TRANSLATE, OnUpdateTranslate)
	ON_COMMAND(ID_ROTATE, OnRotate)
	ON_UPDATE_COMMAND_UI(ID_ROTATE, OnUpdateRotate)
	ON_COMMAND(ID_SCALE, OnScale)
	ON_UPDATE_COMMAND_UI(ID_SCALE, OnUpdateScale)
	ON_COMMAND(ID_HACK, OnHack)
	ON_COMMAND(ID_GHOST, OnGhost)
	ON_UPDATE_COMMAND_UI(ID_GHOST, OnUpdateGhost)
	ON_COMMAND(ID_EDGES, OnEdges)
	ON_UPDATE_COMMAND_UI(ID_EDGES, OnUpdateEdges)
	ON_COMMAND(ID_BACKGROUND, OnBackground)
	ON_UPDATE_COMMAND_UI(ID_BACKGROUND, OnUpdateBackground)
	ON_COMMAND(ID_WIREFRAME, OnWireframe)
	ON_UPDATE_COMMAND_UI(ID_WIREFRAME, OnUpdateWireframe)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModelDoc construction/destruction

CModelDoc::CModelDoc()
{
	// Create the Modeller that is attached to the document.
	modeller = new Mirage::Modeller;
}

CModelDoc::~CModelDoc()
{
  // Delete the Modeller class.
  delete modeller;
}

BOOL CModelDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CModelDoc serialization

void CModelDoc::Serialize(CArchive& ar)
{
  // Not serialized at this time.
}

/////////////////////////////////////////////////////////////////////////////
// CModelDoc diagnostics

#ifdef _DEBUG
void CModelDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CModelDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CModelDoc commands


void CModelDoc::OnLinkAnd() 
{
  // Disable the deletion and other link buttons,
  // make the AND button sunken. Enable the prim menu.
  button_enabled[BUTTON_DELETE] = FALSE;
  button_enabled[BUTTON_PLUS]   = FALSE;
  button_enabled[BUTTON_MINUS]  = FALSE;
  button_enabled[BUTTON_AND]    = TRUE;
  button_enabled[BUTTON_PRIM]   = TRUE;

  // Tell the modeller to set the selection state of all the graphviews.
  modeller->setgraphviewstate(Mirage::VS_LINK_AND);
}

void CModelDoc::OnLinkMinus() 
{
  // Disable the deletion and other link buttons,
  // make the MINUS button sunken. Enable the prim menu.
  button_enabled[BUTTON_DELETE] = FALSE;
  button_enabled[BUTTON_PLUS]   = FALSE;
  button_enabled[BUTTON_MINUS]  = TRUE;
  button_enabled[BUTTON_AND]    = FALSE;
  button_enabled[BUTTON_PRIM]   = TRUE;

  // Tell the modeller to set the selection state of all the graphviews.
  modeller->setgraphviewstate(Mirage::VS_LINK_MINUS);
}

void CModelDoc::OnLinkPlus() 
{
  // Disable the deletion and other link buttons,
  // make the PLUS button sunken. Enable the prim menu.
  button_enabled[BUTTON_DELETE] = FALSE;
  button_enabled[BUTTON_PLUS]   = TRUE;
  button_enabled[BUTTON_MINUS]  = FALSE;
  button_enabled[BUTTON_AND]    = FALSE;
  button_enabled[BUTTON_PRIM]   = TRUE;

  // Tell the modeller to set the selection state of all the graphviews.
  modeller->setgraphviewstate(Mirage::VS_LINK_PLUS);
}

void CModelDoc::OnDelete() 
{
  modeller->do_delete();
}

void CModelDoc::OnSetSelectViewState()
{
  if (modeller->csg_graph->selected_object) {
    button_enabled[BUTTON_DELETE] = TRUE;
    button_enabled[BUTTON_PLUS]   = TRUE;
    button_enabled[BUTTON_MINUS]  = TRUE;
    button_enabled[BUTTON_AND]    = TRUE;
  } else {
    button_enabled[BUTTON_DELETE] = FALSE;
    button_enabled[BUTTON_PLUS]   = FALSE;
    button_enabled[BUTTON_MINUS]  = FALSE;
    button_enabled[BUTTON_AND]    = FALSE;
  }
  button_enabled[BUTTON_PRIM]   = FALSE;
}

void CModelDoc::OnUpdateDelete(CCmdUI* pCmdUI) 
{
  pCmdUI->Enable(button_enabled[BUTTON_DELETE]);
}

void CModelDoc::OnUpdateLinkAnd(CCmdUI* pCmdUI) 
{
  assert(modeller->num_graphviews > 0);
  pCmdUI->SetCheck(modeller->graphview[0]->viewstate == Mirage::VS_LINK_AND);
  pCmdUI->Enable(button_enabled[BUTTON_AND]);
}

void CModelDoc::OnUpdateLinkMinus(CCmdUI* pCmdUI) 
{
  assert(modeller->num_graphviews > 0);
  pCmdUI->SetCheck(modeller->graphview[0]->viewstate == Mirage::VS_LINK_MINUS);
  pCmdUI->Enable(button_enabled[BUTTON_MINUS]);
}

void CModelDoc::OnUpdateLinkPlus(CCmdUI* pCmdUI) 
{
  assert(modeller->num_graphviews > 0);
  pCmdUI->SetCheck(modeller->graphview[0]->viewstate == Mirage::VS_LINK_PLUS);
  pCmdUI->Enable(button_enabled[BUTTON_PLUS]);
}

void CModelDoc::OnUpdatePrimitive(CCmdUI* pCmdUI) 
{
  pCmdUI->Enable(button_enabled[BUTTON_PRIM]);
}

void CModelDoc::OnPrimLink(Mirage::Primitive *new_prim) 
{
  // Cause a link operation to take place.
  assert(modeller->num_graphviews > 0);
  switch(modeller->graphview[0]->viewstate) {
  case Mirage::VS_LINK_PLUS:
    modeller->do_link_prim(new_prim, Mirage::PLUS);
    break;
  case Mirage::VS_LINK_MINUS:
    modeller->do_link_prim(new_prim, Mirage::MINUS);
    break;
  case Mirage::VS_LINK_AND:
    modeller->do_link_prim(new_prim, Mirage::AND);
    break;
  default:
    assert(0);
  }

  // Go back to selection state.
  modeller->setgraphviewstate(Mirage::VS_SELECT);
}

void CModelDoc::OnPrimitiveSphere()
{
  OnPrimLink(new Mirage::spherePrimitive);
}

void CModelDoc::OnPrimitiveCone() 
{
  OnPrimLink(new Mirage::conePrimitive);
}

void CModelDoc::OnPrimitiveCube() 
{
  OnPrimLink(new Mirage::cubePrimitive);
}

void CModelDoc::OnPrimitiveCylinder() 
{
  OnPrimLink(new Mirage::cylinderPrimitive);
}

void CModelDoc::OnPrimitivePlane() 
{
  OnPrimLink(new Mirage::planePrimitive);
}

void CModelDoc::OnPrimitiveTorus() 
{
  OnPrimLink(new Mirage::torusPrimitive(0.3));
}

void CModelDoc::OnPrimitiveTrunccone() 
{
  OnPrimLink(new Mirage::truncConePrimitive(0.7));
}

void CModelDoc::OnPrimitiveUnitcyl() 
{
  OnPrimLink(new Mirage::unitCylinderPrimitive);
}

void CModelDoc::OnUpdatePrimitiveUnitcyl(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(button_enabled[BUTTON_PRIM]);
}

void CModelDoc::OnUpdatePrimitiveSphere(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(button_enabled[BUTTON_PRIM]);
}

void CModelDoc::OnUpdatePrimitiveTrunccone(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(button_enabled[BUTTON_PRIM]);
}

void CModelDoc::OnUpdatePrimitiveTorus(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(button_enabled[BUTTON_PRIM]);
}

void CModelDoc::OnUpdatePrimitivePlane(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(button_enabled[BUTTON_PRIM]);
}

void CModelDoc::OnUpdatePrimitiveCylinder(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(button_enabled[BUTTON_PRIM]);
}

void CModelDoc::OnUpdatePrimitiveCube(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(button_enabled[BUTTON_PRIM]);
}

void CModelDoc::OnUpdatePrimitiveCone(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(button_enabled[BUTTON_PRIM]);
}


void CModelDoc::OnGouraud() 
{
  modeller->set_gouraud(!modeller->use_gouraud);
}

void CModelDoc::OnUpdateGouraud(CCmdUI* pCmdUI) 
{
  // Always enabled.
  pCmdUI->Enable(TRUE);
  pCmdUI->SetCheck(modeller->use_gouraud);
}

void CModelDoc::OnChangeterminal() 
{
//  modeller->cycle_debugging_terminal();
}

void CModelDoc::OnUpdateChangeterminal(CCmdUI* pCmdUI) 
{
  pCmdUI->Enable(modeller->debug_line);
}

void CModelDoc::OnShowterminal() 
{
//  modeller->toggle_debugging_highlight();
}

void CModelDoc::OnUpdateShowterminal(CCmdUI* pCmdUI) 
{
//  pCmdUI->Enable(modeller->terminal_highlight);
//  pCmdUI->SetCheck(modeller->show_only_highlighted);
  pCmdUI->Enable(FALSE);
  pCmdUI->SetCheck(FALSE);
}

void CModelDoc::OnTranslate() 
{
  assert(modeller->num_transviews > 0);
  modeller->transview[0]->add_trans(Mirage::TRANS_TRANSLATION);
}

void CModelDoc::OnUpdateTranslate(CCmdUI* pCmdUI) 
{
  pCmdUI->Enable(modeller->csg_graph->selected_object != NULL);	
}

void CModelDoc::OnRotate() 
{
  assert(modeller->num_transviews > 0);
  modeller->transview[0]->add_trans(Mirage::TRANS_ROTATION);
}

void CModelDoc::OnUpdateRotate(CCmdUI* pCmdUI) 
{
  pCmdUI->Enable(modeller->csg_graph->selected_object != NULL);	
}

void CModelDoc::OnScale() 
{
  assert(modeller->num_transviews > 0);
  modeller->transview[0]->add_trans(Mirage::TRANS_SCALE);
}

void CModelDoc::OnUpdateScale(CCmdUI* pCmdUI) 
{
  pCmdUI->Enable(modeller->csg_graph->selected_object != NULL);	
}

void CModelDoc::OnHack() 
{
  modeller->hack(0);	
}

void CModelDoc::OnGhost() 
{
  assert(modeller->num_modelviews > 0);
  modeller->modelview[0]->set_ghost(!modeller->modelview[0]->show_ghost);
}

void CModelDoc::OnUpdateGhost(CCmdUI* pCmdUI) 
{
  // Enabled if something is selected.
  pCmdUI->Enable(modeller->csg_graph->selected_object != NULL);
  assert(modeller->num_modelviews > 0);
  pCmdUI->SetCheck(modeller->modelview[0]->show_ghost);
}

void CModelDoc::OnEdges() 
{
  assert(modeller->num_modelviews > 0);
  modeller->modelview[0]->set_edges(!modeller->modelview[0]->show_edges);
}

void CModelDoc::OnUpdateEdges(CCmdUI* pCmdUI) 
{
  // Enabled if something is selected.
  pCmdUI->Enable(modeller->csg_graph->selected_object != NULL);
  assert(modeller->num_modelviews > 0);
  pCmdUI->SetCheck(modeller->modelview[0]->show_edges);
}

void CModelDoc::OnBackground() 
{
  assert(modeller->num_modelviews > 0);
  modeller->modelview[0]->set_bg(!modeller->modelview[0]->black_background);
}

void CModelDoc::OnUpdateBackground(CCmdUI* pCmdUI) 
{
  // Always enabled.
  pCmdUI->Enable(TRUE);
  assert(modeller->num_modelviews > 0);
  pCmdUI->SetCheck(modeller->modelview[0]->black_background);
}

void CModelDoc::OnWireframe() 
{
  assert(modeller->num_modelviews > 0);
  modeller->modelview[0]->set_wireframe(!modeller->modelview[0]->draw_wireframe);
}

void CModelDoc::OnUpdateWireframe(CCmdUI* pCmdUI) 
{
  // Always enabled.
  pCmdUI->Enable(TRUE);
  assert(modeller->num_modelviews > 0);
  pCmdUI->SetCheck(modeller->modelview[0]->draw_wireframe);
}
