// ModelDoc.h : interface of the CModelDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MODELDOC_H__50C9826B_6DE8_11D3_BB5F_00105ACE5212__INCLUDED_)
#define AFX_MODELDOC_H__50C9826B_6DE8_11D3_BB5F_00105ACE5212__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Buttons in the document.
typedef enum {BUTTON_AND = 0, BUTTON_PLUS = 1, BUTTON_MINUS = 2,
              BUTTON_DELETE = 3, BUTTON_PRIM = 4} buttonid;

class CModelDoc : public CDocument
{
protected: // create from serialization only
	CModelDoc();
	DECLARE_DYNCREATE(CModelDoc)

// Attributes
public:
	// The Modeller that we are interacting with.
	Mirage::Modeller *modeller;
  int button_enabled[5];


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CModelDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	void OnSetSelectViewState();
  void OnPrimLink(Mirage::Primitive *new_prim);
	void select_button(buttonid id);
	void disable_button(buttonid id);
	void enable_button(buttonid id);

  virtual ~CModelDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CModelDoc)
	afx_msg void OnLinkAnd();
	afx_msg void OnLinkMinus();
	afx_msg void OnLinkPlus();
	afx_msg void OnDelete();
	afx_msg void OnUpdateDelete(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLinkAnd(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLinkMinus(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLinkPlus(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePrimitive(CCmdUI* pCmdUI);
	afx_msg void OnPrimitiveSphere();
	afx_msg void OnUpdatePrimitiveSphere(CCmdUI* pCmdUI);
	afx_msg void OnPrimitiveCone();
	afx_msg void OnUpdatePrimitiveCone(CCmdUI* pCmdUI);
	afx_msg void OnPrimitiveCube();
	afx_msg void OnUpdatePrimitiveCube(CCmdUI* pCmdUI);
	afx_msg void OnPrimitiveCylinder();
	afx_msg void OnUpdatePrimitiveCylinder(CCmdUI* pCmdUI);
	afx_msg void OnPrimitivePlane();
	afx_msg void OnUpdatePrimitivePlane(CCmdUI* pCmdUI);
	afx_msg void OnPrimitiveTorus();
	afx_msg void OnUpdatePrimitiveTorus(CCmdUI* pCmdUI);
	afx_msg void OnPrimitiveTrunccone();
	afx_msg void OnUpdatePrimitiveTrunccone(CCmdUI* pCmdUI);
	afx_msg void OnPrimitiveUnitcyl();
	afx_msg void OnUpdatePrimitiveUnitcyl(CCmdUI* pCmdUI);
	afx_msg void OnGouraud();
	afx_msg void OnUpdateGouraud(CCmdUI* pCmdUI);
	afx_msg void OnChangeterminal();
	afx_msg void OnUpdateChangeterminal(CCmdUI* pCmdUI);
	afx_msg void OnShowterminal();
	afx_msg void OnUpdateShowterminal(CCmdUI* pCmdUI);
	afx_msg void OnTranslate();
	afx_msg void OnUpdateTranslate(CCmdUI* pCmdUI);
	afx_msg void OnRotate();
	afx_msg void OnUpdateRotate(CCmdUI* pCmdUI);
	afx_msg void OnScale();
	afx_msg void OnUpdateScale(CCmdUI* pCmdUI);
	afx_msg void OnHack();
	afx_msg void OnGhost();
	afx_msg void OnUpdateGhost(CCmdUI* pCmdUI);
	afx_msg void OnEdges();
	afx_msg void OnUpdateEdges(CCmdUI* pCmdUI);
	afx_msg void OnBackground();
	afx_msg void OnUpdateBackground(CCmdUI* pCmdUI);
	afx_msg void OnWireframe();
	afx_msg void OnUpdateWireframe(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MODELDOC_H__50C9826B_6DE8_11D3_BB5F_00105ACE5212__INCLUDED_)
