// ModelView.h : interface of the GLView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MODELVIEW_H__B0926274_6C4F_11D1_8F9A_0000C0FB6CD8__INCLUDED_)
#define AFX_MODELVIEW_H__B0926274_6C4F_11D1_8F9A_0000C0FB6CD8__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class ModelView : public CView
{
protected:
  ModelView();
	DECLARE_DYNCREATE(ModelView)

// Attributes
public:

  // The View onto the modelled object.
  class Mirage::View *modeller_view;

public:
  /*
   * These functions are subclassed by the different
   * kinds of ModelView to perform the 3D acceleration.
   */

  // Set up the 3D API.
  virtual HRESULT InitAPI(void);

  // Create the Modeller's view class to interface to.
  virtual class Mirage::View *CreateModellerView(void);

  // Ensure that the right context is selected for rendering.
  virtual void PrepareForRender(void);

  // Release the 3D API.
  virtual void ReleaseAPI(void);

private:

// Operations
public:
  void windowspace_to_viewspace(CPoint windowPt, double *view_x, double *view_y);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(GLView)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~ModelView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(GLView)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MODELVIEW_H__B0926274_6C4F_11D1_8F9A_0000C0FB6CD8__INCLUDED_)
