/*
 * graphview.cc: Routines for GraphView.
 *
 * Contains platform-independent code to interact with the graph.
 */

/* Collection-safe */

#include "stdafx.h"

#ifdef USE_NAMESPACES
namespace Mirage {
#endif

// Routine called when a node is selected in the graphview.
void GraphView::select_node(objectnode *node)
{
  if (node == NULL) {
    modeller->csg_graph->deselect();
  } else {
    modeller->csg_graph->select_element(node);
  }

  modeller->update_all_views();
}

#ifdef USE_NAMESPACES
} // namespace Mirage {
#endif
