/*
 * includelist.h: List of all header files to be included for the CSG modeller.
 */

/* Collection-safe */

#include <mirage.h>
#ifndef _WIN32
#include <assert.h>
#else
#define assert(x) ASSERT(x)
#endif

#include <gl/gl.h>
#include <gl/glu.h>

#ifdef USE_NAMESPACES
namespace Mirage {

// Declare that the following are classes inside namespace
// Mirage... forward declaration.
class View;
class Skitter;
class Primtree;
class Modeller;
class ParentTracker;
class CopyTracker;
class Collection;
class WorldCollection;
class SplitTracker;
class Tracker;
class GraphView;
class LayoutNode;
class TransformList;
class primtreenode;
class primwrappernode;
class ObjectTransformation;
class ObjectScale;
class ObjectRotation;
class ObjectTranslation;
class Terminal;
class WorldStringMemory;
class StringMemory;
class TriMemory;
class SolidOctree;
#if _WIN32
class WGLView;
class WObjectGraphView;
class WTransView;
#endif

#endif

#include "memory.h"
#include "trimem.h"
#include "stringmem.h"
#include "worldstringmem.h"
#include "nodetypes.h"
#include "dmd.h"
#include "transformation.h"
#include "transformlist.h"
#include "csggraph.h"
#include "primtree.h"
#include "copytracker.h"
#include "parenttracker.h"
#include "octree.h"
#include "collection.h"
#include "worldcollection.h"
#include "splittracker.h"
#include "topology.h"
#include "split.h"
#include "skitterlist.h"
#include "view.h"
#include "layout.h"
#include "graphview.h"
#include "transview.h"
#include "modeller.h"

#ifdef USE_NAMESPACES
} // namespace Mirage {
#endif
