/*
 * wtransview.cc: Routines for WTransView.
 *
 * The Windows-specific subclass of TransView that interfaces to
 * the MFC class CTransView.
 */

/* Collection-safe */

#include "stdafx.h"

#ifdef _WIN32

#include "ModelApp.h"
#include "ModelDoc.h"
#include "CTransView.h"
#include "wtransview.h"

#ifdef USE_NAMESPACES
namespace Mirage {
#endif

WTransView::WTransView(Modeller *m, CTransView *transview)
{
  this->modeller = m;
  this->transview = transview;

  modeller->bind_transview(this);

  this->update();
}

// Delete the WTransView.
WTransView::~WTransView()
{
  modeller->unbind_transview(this);
}

// Redraw the WTransView.
void WTransView::redraw(void)
{
  transview->Invalidate();
}

#ifdef USE_NAMESPACES
} // namespace Mirage {
#endif

#endif  // #ifndef _WIN32
