/*
 * wtransview.h: Definitions for WTransView.
 *
 * The Windows-specific subclass of TransView that interfaces to
 * the MFC class CGLTransView.
 */

/* Collection-safe */

#ifdef _WIN32

#ifdef USE_NAMESPACES
namespace Mirage {
#endif

// WTransView is the interface to a Windows CTransView.
class WTransView : public TransView {
public:
  // The Windows class to call.
  class CTransView *transview;

  // Redraw the transview window.
  virtual void redraw(void);

  // Create (and bind) the view.
  WTransView(Modeller *m, CTransView *transview);

  // Delete (and unbind) the view.
  ~WTransView();
};

#ifdef USE_NAMESPACES
} // namespace Mirage {
#endif

#endif  // #ifdef _WIN32

